//
//  Shaders.metal
//  MetalPetalDemo
//
//  Created by Yu Ao on 2019/1/26.
//  Copyright © 2019 MetalPetal. All rights reserved.
//

#include "MTIShaderLib.h"
#include <metal_stdlib>
using namespace metal;

struct ColoredVertex {
    float4 position [[position]];
    float4 color;
};

vertex ColoredVertex demoColoredVertex (const device ColoredVertex * vertices [[ buffer(0) ]], uint vid [[ vertex_id ]], uint instance [[instance_id]]) {
    ColoredVertex vout;
    vout = vertices[vid];
    vout.position *= float4(0.5, 0.5, 1.0, 1.0);
    vout.position += 0.5 * float4(sin(float(instance/18.0 * 3.14159)), cos(float(instance/18.0 * 3.14159)), 0, 0);
    return vout;
}

fragment float4 demoColoredFragment(ColoredVertex vertexIn [[ stage_in ]]) {
    return vertexIn.color;
}

fragment float4 tintBrush(metalpetal::VertexOut vertexIn [[ stage_in ]],
                          texture2d<float, access::sample> colorTexture [[ texture(0) ]],
                          sampler colorSampler [[ sampler(0) ]],
                          constant float4 &color [[ buffer(0) ]]) {
    float4 textureColor = colorTexture.sample(colorSampler, vertexIn.textureCoordinate);
    textureColor.rgb = color.rgb;
    textureColor.a *= color.a;
    return textureColor;
}

fragment float4 magicTintBrushIconGenerator(metalpetal::VertexOut vertexIn [[ stage_in ]]) {
    return float4(vertexIn.textureCoordinate.x, vertexIn.textureCoordinate.y, 1, 1);
}
